<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:rich="http://richfaces.org/rich"
                xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns="http://www.w3.org/1999/xhtml"
                template="/layout/template.xhtml">
    <ui:define name="body">
        <h1>#{messages['net.ihe.gazelle.xdstar.TransactionTypes']}</h1>
        <h:form id="globalForm">
            <s:div id="globalDiv">
                <gri:panel id="listTransactionTypePanel">
                    <f:facet name="header">#{messages['net.ihe.gazelle.xdstar.ListTransactionType']}</f:facet>
                    <a4j:commandButton actionListener="#{TTManager.init()}" styleClass="gzl-btn-green"
                                       value="#{messages['net.ihe.gazelle.xdstar.CreateTransactionType']}"
                                       oncomplete="jq162('#addTT').modal('show');" execute="@this"
                                       render="addTT,addTransactionTypeForm"/>
                    <rich:dataTable id="configTable" value="#{TTManager.getListTransactionType()}" var="currentConfig"
                                    rows="10"
                                    render="ds">
                        <g:column id="nameColumn" filterBy="#{currentConfig.name}" filterEvent="onkeyup"
                                  orderBy="#{currentConfig.name}"
                                  sortOrder="ascending">
                            <ui:define name="header">#{messages['net.ihe.gazelle.xdstar.Name']}</ui:define>
                            <h:outputText value="#{currentConfig.name}"/>
                        </g:column>
                        <g:column id="urlColumn">
                            <ui:define name="header">#{messages['net.ihe.gazelle.xdstar.Transactions']}</ui:define>
                            <a4j:repeat value="#{currentConfig.listTransactions}" var="trans">
                                <h:outputText value="#{trans.keyword}"/>
                                <br/>
                            </a4j:repeat>
                        </g:column>
                        <g:column id="actionColumn">
                            <ui:define name="header">#{messages['net.ihe.gazelle.xdstar.Action']}</ui:define>
                            <a4j:commandLink actionListener="#{TTManager.setSelectedTransactionType(currentConfig)}"
                                             oncomplete="jq162('#addTT').modal('show');"
                                             execute="@this" render="globalDiv,addTT,addTransactionTypeForm">
                                <span class="gzl-icon-pencil"/>
                            </a4j:commandLink>
                            <gdk:spacer width="5"/>
                            <a4j:commandLink actionListener="#{TTManager.setSelectedTransactionType(currentConfig)}"
                                             oncomplete="jq162('#deleteTT').modal('show');" execute="@this"
                                             render="globalDiv,deleteTT,deleteTransactionTypeForm">
                                <span class="gzl-icon-trash-o"/>
                            </a4j:commandLink>
                        </g:column>
                        <f:facet name="footer">
                            <s:div style="text-align: center;">
                                <rich:dataScroller id="ds" maxPages="10" renderIfSinglePage="false" immediate="true"/>
                            </s:div>
                        </f:facet>
                    </rich:dataTable>
                </gri:panel>
                <gri:panel id="listAffinityDomainPanel">
                    <f:facet name="header">#{messages['net.ihe.gazelle.xdstar.ListAffinityDomain']}</f:facet>
                    <a4j:commandButton styleClass="gzl-btn-green"
                                       value="#{messages['net.ihe.gazelle.xdstar.CreateAffinityDomain']}"
                                       actionListener="#{TTManager.init()}"
                                       oncomplete="jq162('#addAffinityDomain').modal('show');"
                                       execute="@this" render="addAffinityDomain,addAffinityDomainForm"/>
                    <rich:dataTable value="#{affinityDomain.listAllAffinityDomains()}" var="currentConfig" rows="10"
                                    render="ds">
                        <g:column filterBy="#{currentConfig.labelToDisplay}" filterEvent="onkeyup"
                                  orderBy="#{currentConfig.labelToDisplay}"
                                  sortOrder="ascending">
                            <ui:define name="header">#{messages['net.ihe.gazelle.xdstar.LabelToDisplay']}</ui:define>
                            <h:outputText value="#{currentConfig.labelToDisplay}"/>
                        </g:column>
                        <g:column filterBy="#{currentConfig.profile}" filterEvent="onkeyup"
                                  orderBy="#{currentConfig.profile}" sortOrder="ascending">
                            <ui:define name="header">#{messages['net.ihe.gazelle.xdstar.Profile']}</ui:define>
                            <h:outputText value="#{currentConfig.profile}"/>
                        </g:column>
                        <g:column filterBy="#{currentConfig.keyword}" filterEvent="onkeyup"
                                  orderBy="#{currentConfig.keyword}" sortOrder="ascending">
                            <ui:define name="header">#{messages['net.ihe.gazelle.xdstar.Keyword']}</ui:define>
                            <h:outputText value="#{currentConfig.keyword}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.xdstar.Transactions']}</ui:define>
                            <a4j:repeat value="#{currentConfig.supportedTransactions}" var="trans">
                                <h:outputText value="#{trans.keyword}"/>
                                <br/>
                            </a4j:repeat>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.xdstar.Action']}</ui:define>
                            <a4j:commandLink actionListener="#{TTManager.setSelectedAffinityDomain(currentConfig)}"
                                             oncomplete="jq162('#addAffinityDomain').modal('show');"
                                             execute="@this" render="globalDiv,addAffinityDomain,addAffinityDomainForm">
                                <span class="gzl-icon-pencil"/>
                            </a4j:commandLink>
                            <gdk:spacer width="5"/>
                            <a4j:commandLink actionListener="#{TTManager.setSelectedAffinityDomain(currentConfig)}"
                                             oncomplete="jq162('#deleteAffinityDomain').modal('show');"
                                             execute="@this" render="globalDiv,deleteAffinityDomainForm,deleteAffinityDomain">
                                <span class="gzl-icon-trash-o"/>
                            </a4j:commandLink>
                        </g:column>
                        <f:facet name="footer">
                            <s:div style="text-align: center;">
                                <rich:dataScroller id="ds" maxPages="10" renderIfSinglePage="false" immediate="true"/>
                            </s:div>
                        </f:facet>
                    </rich:dataTable>
                </gri:panel>
                <gri:panel id="listTransactionsPanel">
                    <f:facet name="header">#{messages['net.ihe.gazelle.xdstar.ListTransactions']}</f:facet>
                    <a4j:commandButton
                            value="#{messages['net.ihe.gazelle.xdstar.CreateTransaction']}" styleClass="gzl-btn-green"
                            actionListener="#{TTManager.init()}"
                            oncomplete="jq162('#addTrans').modal('show');" execute="@this"
                            render="addTrans,addTransactionForm"/>
                    <rich:dataTable value="#{transaction.ListAllTransactions()}" var="currentConfig" rows="10"
                                    render="ds">
                        <g:column filterBy="#{currentConfig.name}" filterEvent="onkeyup" orderBy="#{currentConfig.name}"
                                  sortOrder="ascending">
                            <ui:define name="header">#{messages['net.ihe.gazelle.xdstar.Name_2']}</ui:define>
                            <h:outputText value="#{currentConfig.name}"/>
                        </g:column>
                        <g:column filterBy="#{currentConfig.keyword}" filterEvent="onkeyup"
                                  orderBy="#{currentConfig.keyword}" sortOrder="ascending">
                            <ui:define name="header">#{messages['net.ihe.gazelle.xdstar.Keyword']}</ui:define>
                            <h:outputText value="#{currentConfig.keyword}"/>
                        </g:column>
                        <g:column filterBy="#{currentConfig.description}" filterEvent="onkeyup"
                                  orderBy="#{currentConfig.description}"
                                  sortOrder="ascending">
                            <ui:define name="header">#{messages['net.ihe.gazelle.xdstar.Description_2']}</ui:define>
                            <h:outputText value="#{currentConfig.description}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.xdstar.Action']}</ui:define>
                            <a4j:commandLink actionListener="#{TTManager.setSelectedTransaction(currentConfig)}"
                                             oncomplete="jq162('#addTrans').modal('show');"
                                             execute="@this" render="globalDiv,addTrans,addTransactionForm">
                                <span class="gzl-icon-pencil"/>
                            </a4j:commandLink>
                            <gdk:spacer width="5"/>
                            <a4j:commandLink actionListener="#{TTManager.setSelectedTransaction(currentConfig)}"
                                             execute="@this" render="globalDiv,deleteTransactionForm,deleteTrans"
                                             oncomplete="jq162('#deleteTrans').modal('show');">
                                <span class="gzl-icon-trash-o"/>
                            </a4j:commandLink>
                        </g:column>
                        <f:facet name="footer">
                            <s:div style="text-align: center;">
                                <rich:dataScroller id="ds" maxPages="10" renderIfSinglePage="false" immediate="true"/>
                            </s:div>
                        </f:facet>
                    </rich:dataTable>
                </gri:panel>
                <br/>
            </s:div>
        </h:form>

        <h:form id="addTransactionTypeForm">
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="addTT"/>
                <ui:param name="bodyStyleClass" value="gzl-select-modal-overflow-visible"/>
                <ui:param name="styleClass" value="modal-lg"/>
                <ui:define name="popup_title">#{messages['net.ihe.gazelle.xdstar.ADDTransactionType']}</ui:define>
                <div class="form-horizontal">
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.Name']}</ui:define>
                        <ui:param name="id" value="TransactionTypeNameInput"/>
                        <h:inputText id="TransactionTypeNameInput" value="#{TTManager.selectedTransactionType.name}" required="true" styleClass="form-control"/>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.Transactions']}</ui:define>
                        <ui:param name="id" value="TransactionTypeTransactionsInput"/>
                        <rich:pickList id="TransactionTypeTransactionsInput" value="#{TTManager.selectedTransactionType.listTransactions}"
                                       listWidth="250px" listHeight="100px">
                            <s:selectItems value="#{transaction.ListAllTransactions()}" var="currentTR"
                                           label="#{currentTR.keyword}"/>
                        </rich:pickList>
                    </s:decorate>
                </div>
                <ui:define name="popup_footer">
                    <a4j:commandButton styleClass="gzl-btn"
                                       value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                       onclick="jq162('#addTT').modal('hide');" execute="@this"/>
                    <h:commandButton styleClass="gzl-btn-green"
                                       value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                       actionListener="#{TTManager.mergeObject(TTManager.selectedTransactionType)}"
                                       oncomplete="jq162('#addTT').modal('hide');"
                                       render="globalForm,globalDiv"/>
                </ui:define>
            </ui:decorate>
        </h:form>

        <h:form id="deleteTransactionTypeForm">
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="deleteTT"/>
                <ui:param name="bodyStyleClass" value="gzl-select-modal-overflow-visible"/>
                <ui:define name="popup_title">#{messages['net.ihe.gazelle.xdstar.DeleteTransactionType']}</ui:define>
                <s:decorate template="/layout/form/_edit.xhtml">
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.xdstar.DoYouReallyWantToDeleteThisTransactionType']}"/>
                </s:decorate>
                <ui:define name="popup_footer">
                    <a4j:commandButton styleClass="gzl-btn"
                                       value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                       onclick="jq162('#deleteTT').modal('hide');" execute="@this"/>
                    <a4j:commandButton styleClass="gzl-btn-red"
                                       value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                       actionListener="#{TTManager.deleteSelectedTransactionType()}"
                                       onclick="jq162('#deleteTT').modal('hide');"
                                       render="globalForm,globalDiv,listTransactionTypePanel"/>
                </ui:define>
            </ui:decorate>
        </h:form>

        <h:form id="addAffinityDomainForm">
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="addAffinityDomain"/>
                <ui:param name="styleClass" value="modal-lg"/>
                <ui:define name="popup_title">#{messages['net.ihe.gazelle.xdstar.ADDAffinityDomain']}</ui:define>
                <div class="form-horizontal">
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.LabelToDisplay']}</ui:define>
                        <ui:param name="id" value="affinityDomainLabelToDisplayInput"/>
                        <h:inputText id="affinityDomainLabelToDisplayInput" value="#{TTManager.selectedAffinityDomain.labelToDisplay}"
                                     styleClass="form-control"/>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.Profile']}</ui:define>
                        <ui:param name="id" value="affinityDomainProfileInput"/>
                        <h:inputText id="affinityDomainProfileInput" value="#{TTManager.selectedAffinityDomain.profile}" styleClass="form-control"/>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.Keyword']}</ui:define>
                        <ui:param name="id" value="affinityDomainKeywordInput"/>
                        <h:inputText id="affinityDomainKeywordInput" value="#{TTManager.selectedAffinityDomain.keyword}" required="true" styleClass="form-control"/>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.Transactions']}</ui:define>
                        <ui:param name="id" value="affinityDomainTransactionsInput"/>
                        <rich:pickList id="affinityDomainTransactionsInput" value="#{TTManager.selectedAffinityDomain.supportedTransactions}"
                                       listWidth="250px" listHeight="100px">
                            <s:selectItems value="#{transaction.ListAllTransactions()}" var="currentTR"
                                           label="#{currentTR.keyword}"/>
                        </rich:pickList>
                    </s:decorate>
                </div>
                <ui:define name="popup_footer">
                    <a4j:commandButton styleClass="gzl-btn"
                                       value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                       onclick="jq162('#addAffinityDomain').modal('hide');"
                                       execute="@this"/>
                    <a4j:commandButton styleClass="gzl-btn-green"
                                       value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                       actionListener="#{TTManager.mergeObject(TTManager.selectedAffinityDomain)}"
                                       onclick="jq162('#addAffinityDomain').modal('hide');"
                                       render="globalForm,globalDiv,listAffinityDomainPanel"/>
                </ui:define>
            </ui:decorate>
        </h:form>

        <h:form id="deleteAffinityDomainForm">
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="deleteAffinityDomain"/>
                <ui:define name="popup_title">#{messages['net.ihe.gazelle.xdstar.DeleteAffinityDomain']}</ui:define>
                <s:decorate template="/layout/form/_edit.xhtml">
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.xdstar.DoYouReallyWantToDeleteThisAffinityDomain']}"/>
                </s:decorate>
                <ui:define name="popup_footer">
                    <a4j:commandButton styleClass="gzl-btn"
                                       value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                       onclick="jq162('#deleteAffinityDomain').modal('hide');" execute="@this"/>
                    <a4j:commandButton styleClass="gzl-btn-red"
                                       value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                       actionListener="#{TTManager.deleteSelectedAffinityDomain()}"
                                       onclick="jq162('#deleteAffinityDomain').modal('hide');"
                                       render="globalForm,globalDiv,listAffinityDomainPanel"/>
                </ui:define>
            </ui:decorate>
        </h:form>

        <h:form id="addTransactionForm">
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="addTrans"/>
                <ui:param name="bodyStyleClass" value="gzl-select-modal-overflow-visible"/>
                <ui:param name="styleClass" value="modal-lg"/>
                <ui:define name="popup_title">#{messages['net.ihe.gazelle.xdstar.ADDTransaction']}</ui:define>
                <div class="form-horizontal">
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.Name']}</ui:define>
                        <ui:param name="id" value="TransactionsNameInput"/>
                        <h:inputText id="TransactionsNameInput" value="#{TTManager.selectedTransaction.name}" styleClass="form-control"/>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.Keyword_2']}</ui:define>
                        <ui:param name="id" value="transactionKeywordInput"/>
                        <h:inputText id="transactionKeywordInput" value="#{TTManager.selectedTransaction.keyword}" required="true" styleClass="form-control"/>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.Description']}</ui:define>
                        <ui:param name="id" value="TransactionsDescriptionInput"/>
                        <h:inputText id="TransactionsDescriptionInput" value="#{TTManager.selectedTransaction.description}" styleClass="form-control"/>
                    </s:decorate>
                </div>
                <ui:define name="popup_footer">
                    <a4j:commandButton styleClass="gzl-btn"
                                       value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                       onclick="jq162('#addTrans').modal('hide');" execute="@this"/>
                    <a4j:commandButton styleClass="gzl-btn-green"
                                       value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                       actionListener="#{TTManager.mergeObject(TTManager.selectedTransaction)}"
                                       onclick="jq162('#addTrans').modal('hide');"
                                       render="globalForm,globalDiv,listTransactionsPanel"/>
                </ui:define>
            </ui:decorate>
        </h:form>

        <h:form id="deleteTransactionForm">
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="deleteTrans"/>
                <ui:param name="bodyStyleClass" value="gzl-select-modal-overflow-visible"/>
                <ui:define name="popup_title">#{messages['net.ihe.gazelle.xdstar.DeleteTransaction']}</ui:define>
                <s:decorate template="/layout/form/_edit.xhtml">
                    <h:outputText value="#{messages['net.ihe.gazelle.xdstar.DoYouReallyWantToDeleteThisTransaction']}"/>
                </s:decorate>
                <ui:define name="popup_footer">
                    <a4j:commandButton styleClass="gzl-btn"
                                       value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                       onclick="jq162('#deleteTrans').modal('hide');" execute="@this"/>
                    <a4j:commandButton styleClass="gzl-btn-red"
                                       value="#{messages['net.ihe.gazelle.xdstar.Confirm']}"
                                       actionListener="#{TTManager.deleteSelectedTransaction()}"
                                       onclick="jq162('#deleteTrans').modal('hide');"
                                       render="globalForm,globalDiv,listTransactionsPanel"/>
                </ui:define>
            </ui:decorate>
        </h:form>
    </ui:define>
</ui:composition>
